
const PanelMenu = imports.ui.panelMenu;
const Clutter = imports.gi.Clutter;
const St = imports.gi.St;
const Main = imports.ui.main;
const Keymap = imports.gi.Gdk.Keymap.get_default();

let indicator;

function updateState()
{
    let numlock_state = Keymap.get_num_lock_state(), capslock_state = Keymap.get_caps_lock_state();

    if ((indicator.actor.visible = (numlock_state | capslock_state)) == false)
        return;

    numlock_state ? indicator.numIcon.show() : indicator.numIcon.hide();
    capslock_state ? indicator.capsIcon.show() : indicator.capsIcon.hide();
}

function enable()
{
    indicator = new PanelMenu.Button(this, St.Align.START);

    indicator.numIcon = new St.Label({ style_class: "icon-style", y_align: Clutter.ActorAlign.CENTER, visible: true, text: "1"});
    indicator.capsIcon = new St.Label({ style_class: "icon-style", y_align: Clutter.ActorAlign.CENTER, visible: true, text: "A"});

    indicator.layoutManager = new St.BoxLayout();
    indicator.layoutManager.add_child(indicator.numIcon);
    indicator.layoutManager.add_child(indicator.capsIcon);

    indicator.actor.add_actor(indicator.layoutManager);

    Main.panel.addToStatusArea('lockkeys', indicator, 2);
    indicator._keyboardStateChangedId = Keymap.connect('state-changed', updateState);
    updateState();
}

function disable()
{
    Keymap.disconnect(indicator._keyboardStateChangedId);
    indicator.destroy();
}
